/[gentoo-x86]/eclass/vdr-plugin.eclass
Gentoo

Diff of /eclass/vdr-plugin.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.49 Revision 1.83
1# Copyright 1999-2005 Gentoo Foundation 1# Copyright 1999-2012 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/Attic/vdr-plugin.eclass,v 1.49 2007/08/16 17:59:21 zzam Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/Attic/vdr-plugin.eclass,v 1.83 2012/03/09 23:14:46 hd_brummy Exp $
4
5# @ECLASS: vdr-plugin.eclass
6# @MAINTAINER:
7# vdr@gentoo.org
8# @BLURB: common vdr plugin ebuild functions
9# @DESCRIPTION:
10# Eclass for easing maitenance of vdr plugin ebuilds
11
12# Authors:
13# Matthias Schwarzott <zzam@gentoo.org>
14# Joerg Bornkessel <hd_brummy@gentoo.org>
15# Christian Ruppert <idl0r@gentoo.org>
16
17# Plugin config file installation:
4# 18#
5# Author: 19# A plugin config file can be specified through the $VDR_CONFD_FILE variable, it
6# Matthias Schwarzott <zzam@gentoo.org> 20# defaults to ${FILESDIR}/confd. Each config file will be installed as e.g.
7# Joerg Bornkessel <hd_brummy@gentoo.org> 21# ${D}/etc/conf.d/vdr.${VDRPLUGIN}
8 22
9# vdr-plugin.eclass 23# Installation of rc-addon files:
24# NOTE: rc-addon files must be valid shell scripts!
10# 25#
11# eclass to create ebuilds for vdr plugins 26# Installing rc-addon files is basically the same as for plugin config files
27# (see above), it's just using the $VDR_RCADDON_FILE variable instead.
28# The default value when $VDR_RCADDON_FILE is undefined is:
29# ${FILESDIR}/rc-addon.sh and will be installed as
30# ${VDR_RC_DIR}/plugin-${VDRPLUGIN}.sh
12# 31#
32# The rc-addon files will be sourced by the startscript when the specific plugin
33# has been enabled.
34# rc-addon files may be used to prepare everything that is necessary for the
35# plugin start/stop, like passing extra command line options and so on.
13 36
14# Example ebuild (vdr-femon): 37# Applying your own local/user patches:
38# This is done by using the epatch_user() function of the eutils.eclass.
39# Simply put your patches into one of these directories:
40# /etc/portage/patches/<CATEGORY>/<PF|P|PN>/
41# Quote: where the first of these three directories to exist will be the one to
42# use, ignoring any more general directories which might exist as well.
15# 43#
16# inherit vdr-plugin 44# For more details about it please take a look at the eutils.class.
17# IUSE=""
18# SLOT="0"
19# DESCRIPTION="vdr Plugin: DVB Frontend Status Monitor (signal strengt/noise)"
20# HOMEPAGE="http://www.saunalahti.fi/~rahrenbe/vdr/femon/"
21# SRC_URI="http://www.saunalahti.fi/~rahrenbe/vdr/femon/files/${P}.tgz"
22# LICENSE="GPL-2"
23# KEYWORDS="~x86"
24# DEPEND=">=media-video/vdr-1.3.27"
25#
26#
27
28# Installation of a config file for the plugin
29#
30# If ${VDR_CONFD_FILE} is set install this file
31# else install ${FILESDIR}/confd if it exists.
32
33# Gets installed as /etc/conf.d/vdr.${VDRPLUGIN}.
34# For the plugin vdr-femon this would be /etc/conf.d/vdr.femon
35
36
37# Installation of an rc-addon file for the plugin
38#
39# If ${VDR_RCADDON_FILE} is set install this file
40# else install ${FILESDIR}/rc-addon.sh if it exists.
41#
42# Gets installed under ${VDR_RC_DIR}/plugin-${VDRPLUGIN}.sh
43# (in example vdr-femon this would be /usr/share/vdr/rcscript/plugin-femon.sh)
44#
45# This file is sourced by the startscript when plugin is activated in /etc/conf.d/vdr
46# It could be used for special startup actions for this plugins, or to create the
47# plugin command line options from a nicer version of a conf.d file.
48
49# HowTo use own local patches; Example
50#
51# Add to your /etc/make.conf:
52# VDR_LOCAL_PATCHES_DIR="/usr/local/patch"
53#
54# Add two DIR's in your local patch dir, ${PN}/${PV},
55# e.g for vdr-burn-0.1.0 should be:
56# /usr/local/patch/vdr-burn/0.1.0/
57#
58# all patches which ending on diff or patch in this DIR will automatically applied
59#
60 45
61inherit base multilib eutils flag-o-matic 46inherit base multilib eutils flag-o-matic
47
48if ! has "${EAPI:-0}" 0 1 2 3 4; then
49 die "API of vdr-plugin.eclass in EAPI=\"${EAPI}\" not established"
50fi
62 51
63IUSE="" 52IUSE=""
64 53
65# Name of the plugin stripped from all vdrplugin-, vdr- and -cvs pre- and postfixes 54# Name of the plugin stripped from all vdrplugin-, vdr- and -cvs pre- and postfixes
66VDRPLUGIN="${PN/#vdrplugin-/}" 55VDRPLUGIN="${PN/#vdrplugin-/}"
71 60
72# works in most cases 61# works in most cases
73S="${WORKDIR}/${VDRPLUGIN}-${PV}" 62S="${WORKDIR}/${VDRPLUGIN}-${PV}"
74 63
75# depend on headers for DVB-driver 64# depend on headers for DVB-driver
76RDEPEND=">=media-tv/gentoo-vdr-scripts-0.3.4-r1" 65COMMON_DEPEND=">=media-tv/gentoo-vdr-scripts-0.4.2"
77DEPEND="media-tv/linuxtv-dvb-headers"
78 66
67DEPEND="${COMMON_DEPEND}
68 virtual/linuxtv-dvb-headers"
69RDEPEND="${COMMON_DEPEND}
70 >=app-admin/eselect-vdr-0.0.2"
79 71
80# this code is from linux-mod.eclass 72# this is a hack for ebuilds like vdr-xineliboutput that want to
81update_vdrplugindb() { 73# conditionally install a vdr-plugin
82 local VDRPLUGINDB_DIR=${ROOT}/var/lib/vdrplugin-rebuild/ 74if [[ "${GENTOO_VDR_CONDITIONAL:-no}" = "yes" ]]; then
83 75 # make DEPEND conditional
84 if [[ ! -f ${VDRPLUGINDB_DIR}/vdrplugindb ]]; then 76 IUSE="${IUSE} vdr"
85 [[ ! -d ${VDRPLUGINDB_DIR} ]] && mkdir -p ${VDRPLUGINDB_DIR} 77 DEPEND="vdr? ( ${DEPEND} )"
86 touch ${VDRPLUGINDB_DIR}/vdrplugindb 78 RDEPEND="vdr? ( ${RDEPEND} )"
87 fi 79fi
88 if [[ -z $(grep ${CATEGORY}/${PN}-${PVR} ${VDRPLUGINDB_DIR}/vdrplugindb) ]]; then
89 einfo "Adding plugin to vdrplugindb."
90 echo "a:1:${CATEGORY}/${PN}-${PVR}" >> ${VDRPLUGINDB_DIR}/vdrplugindb
91 fi
92}
93
94remove_vdrplugindb() {
95 local VDRPLUGINDB_DIR=${ROOT}/var/lib/vdrplugin-rebuild/
96
97 if [[ -n $(grep ${CATEGORY}/${PN}-${PVR} ${VDRPLUGINDB_DIR}/vdrplugindb) ]]; then
98 einfo "Removing ${CATEGORY}/${PN}-${PVR} from vdrplugindb."
99 sed -ie "/.*${CATEGORY}\/${P}.*/d" ${VDRPLUGINDB_DIR}/vdrplugindb
100 fi
101}
102 80
103# New method of storing plugindb 81# New method of storing plugindb
104# Called from src_install 82# Called from src_install
105# file maintained by normal portage-methods 83# file maintained by normal portage-methods
106create_plugindb_file() { 84create_plugindb_file() {
107 local NEW_VDRPLUGINDB_DIR=/usr/share/vdr/vdrplugin-rebuild/ 85 local NEW_VDRPLUGINDB_DIR=/usr/share/vdr/vdrplugin-rebuild/
108 local DB_FILE=${NEW_VDRPLUGINDB_DIR}/${CATEGORY}-${PF} 86 local DB_FILE="${NEW_VDRPLUGINDB_DIR}/${CATEGORY}-${PF}"
109 insinto ${NEW_VDRPLUGINDB_DIR} 87 insinto "${NEW_VDRPLUGINDB_DIR}"
88
89# BUG: portage-2.1.4_rc9 will delete the EBUILD= line, so we cannot use this code.
110 cat <<-EOT > ${D}/${DB_FILE} 90# cat <<-EOT > "${D}/${DB_FILE}"
111 VDRPLUGIN_DB=1 91# VDRPLUGIN_DB=1
112 CREATOR=ECLASS 92# CREATOR=ECLASS
113 EBUILD=${CATEGORY}/${PN} 93# EBUILD=${CATEGORY}/${PN}
114 EBUILD_V=${PVR} 94# EBUILD_V=${PVR}
115 EOT 95# EOT
96 {
97 echo "VDRPLUGIN_DB=1"
98 echo "CREATOR=ECLASS"
99 echo "EBUILD=${CATEGORY}/${PN}"
100 echo "EBUILD_V=${PVR}"
101 echo "PLUGINS=\"$@\""
102 } > "${D}/${DB_FILE}"
116} 103}
117 104
118# Delete files created outside of vdr-plugin.eclass 105# Delete files created outside of vdr-plugin.eclass
119# vdrplugin-rebuild.ebuild converted plugindb and files are 106# vdrplugin-rebuild.ebuild converted plugindb and files are
120# not deleted by portage itself - should only be needed as 107# not deleted by portage itself - should only be needed as
121# long as not every system has switched over to 108# long as not every system has switched over to
122# vdrplugin-rebuild-0.2 109# vdrplugin-rebuild-0.2 / gentoo-vdr-scripts-0.4.2
123delete_orphan_plugindb_file() { 110delete_orphan_plugindb_file() {
124 #elog Testing for orphaned plugindb file 111 #elog Testing for orphaned plugindb file
125 local NEW_VDRPLUGINDB_DIR=/usr/share/vdr/vdrplugin-rebuild/ 112 local NEW_VDRPLUGINDB_DIR=/usr/share/vdr/vdrplugin-rebuild/
126 local DB_FILE=${ROOT}/${NEW_VDRPLUGINDB_DIR}/${CATEGORY}-${PF} 113 local DB_FILE="${ROOT}/${NEW_VDRPLUGINDB_DIR}/${CATEGORY}-${PF}"
127 114
128 # file exists 115 # file exists
129 [[ -f ${DB_FILE} ]] || return 116 [[ -f ${DB_FILE} ]] || return
130 117
131 # will portage handle the file itself 118 # will portage handle the file itself
132 if grep -q CREATOR=ECLASS ${DB_FILE}; then 119 if grep -q CREATOR=ECLASS "${DB_FILE}"; then
133 #elog file owned by eclass - don't touch it 120 #elog file owned by eclass - don't touch it
134 return 121 return
135 fi 122 fi
136 123
137 elog "Removing orphaned plugindb-file." 124 elog "Removing orphaned plugindb-file."
138 elog "\t#rm ${DB_FILE}" 125 elog "\t#rm ${DB_FILE}"
139 rm ${DB_FILE} 126 rm "${DB_FILE}"
140} 127}
141 128
142 129
143create_header_checksum_file() 130create_header_checksum_file()
144{ 131{
145 # Danger: Not using $ROOT here, as compile will also not use it !!! 132 # Danger: Not using $ROOT here, as compile will also not use it !!!
146 # If vdr in $ROOT and / differ, plugins will not run anyway 133 # If vdr in $ROOT and / differ, plugins will not run anyway
147 134
148 insinto ${VDR_CHECKSUM_DIR} 135 local CHKSUM="header-md5-vdr"
136
149 if [[ -f ${VDR_CHECKSUM_DIR}/header-md5-vdr ]]; then 137 if [[ -f ${VDR_CHECKSUM_DIR}/header-md5-vdr ]]; then
150 newins ${VDR_CHECKSUM_DIR}/header-md5-vdr header-md5-${PN} 138 cp "${VDR_CHECKSUM_DIR}/header-md5-vdr" "${CHKSUM}"
139 elif type -p md5sum >/dev/null 2>&1; then
140 (
141 cd "${VDR_INCLUDE_DIR}"
142 md5sum *.h libsi/*.h|LC_ALL=C sort --key=2
143 ) > "${CHKSUM}"
151 else 144 else
152 if type -p md5sum >/dev/null 2>&1; then 145 die "Could not create md5 checksum of headers"
153 cd ${S} 146 fi
154 ( 147
155 cd ${VDR_INCLUDE_DIR} 148 insinto "${VDR_CHECKSUM_DIR}"
156 md5sum *.h libsi/*.h|LC_ALL=C sort --key=2 149 local p_name
157 ) > header-md5-${PN} 150 for p_name; do
158 doins header-md5-${PN} 151 newins "${CHKSUM}" "header-md5-${p_name}"
152 done
153}
154
155fix_vdr_libsi_include()
156{
157 #einfo "Fixing include of libsi-headers"
158 local f
159 for f; do
160 sed -i "${f}" \
161 -e '/#include/s:"\(.*libsi.*\)":<\1>:' \
162 -e '/#include/s:<.*\(libsi/.*\)>:<vdr/\1>:'
163 done
164}
165
166vdr_patchmakefile() {
167 einfo "Patching Makefile"
168 [[ -e Makefile ]] || die "Makefile of plugin can not be found!"
169 cp Makefile "${WORKDIR}"/Makefile.before
170
171 # plugin makefiles use VDRDIR in strange ways
172 # assumptions:
173 # 1. $(VDRDIR) contains Make.config
174 # 2. $(VDRDIR) contains config.h
175 # 3. $(VDRDIR)/include/vdr contains the headers
176 # 4. $(VDRDIR) contains main vdr Makefile
177 # 5. $(VDRDIR)/locale exists
178 # 6. $(VDRDIR) allows to access vdr source files
179 #
180 # We only have one directory (for now /usr/include/vdr),
181 # that contains vdr-headers and Make.config.
182 # To satisfy 1-3 we do this:
183 # Set VDRDIR=/usr/include/vdr
184 # Set VDRINCDIR=/usr/include
185 # Change $(VDRDIR)/include to $(VDRINCDIR)
186
187 sed -i Makefile \
188 -e "s:^VDRDIR.*$:VDRDIR = ${VDR_INCLUDE_DIR}:" \
189 -e "/^VDRDIR/a VDRINCDIR = ${VDR_INCLUDE_DIR%/vdr}" \
190 -e '/VDRINCDIR.*=/!s:$(VDRDIR)/include:$(VDRINCDIR):' \
191 \
192 -e 's:-I$(DVBDIR)/include::' \
193 -e 's:-I$(DVBDIR)::'
194
195 # maybe needed for multiproto:
196 #sed -i Makefile \
197 # -e "s:^DVBDIR.*$:DVBDIR = ${DVB_INCLUDE_DIR}:" \
198 # -e 's:-I$(DVBDIR)/include:-I$(DVBDIR):'
199
200 if ! grep -q APIVERSION Makefile; then
201 ebegin " Converting to APIVERSION"
202 sed -i Makefile \
203 -e 's:^APIVERSION = :APIVERSION ?= :' \
204 -e 's:$(LIBDIR)/$@.$(VDRVERSION):$(LIBDIR)/$@.$(APIVERSION):' \
205 -e '/VDRVERSION =/a\APIVERSION = $(shell sed -ne '"'"'/define APIVERSION/s/^.*"\\(.*\\)".*$$/\\1/p'"'"' $(VDRDIR)/config.h)'
206 eend $?
207 fi
208
209 # Correcting Compile-Flags
210 # Do not overwrite CXXFLAGS, add LDFLAGS if missing
211 sed -i Makefile \
212 -e '/^CXXFLAGS[[:space:]]*=/s/=/?=/' \
213 -e '/LDFLAGS/!s:-shared:$(LDFLAGS) -shared:'
214
215 # Disabling file stripping, useful for debugging
216 sed -i Makefile \
217 -e '/@.*strip/d' \
218 -e '/strip \$(LIBDIR)\/\$@/d' \
219 -e 's/STRIP.*=.*$/STRIP = true/'
220
221 # Use a file instead of a variable as single-stepping via ebuild
222 # destroys environment.
223 touch "${WORKDIR}"/.vdr-plugin_makefile_patched
224}
225
226vdr_has_gettext() {
227 has_version ">=media-video/vdr-1.5.7"
228}
229
230plugin_has_gettext() {
231 [[ -d po ]]
232}
233
234vdr_i18n_convert_to_gettext() {
235 if has_version ">=media-video/vdr-1.7.22"; then
236 local i18n_tool="${ROOT}/usr/share/vdr/bin/i18n-to-gettext"
237 else
238 local i18n_tool="${ROOT}/usr/share/vdr/bin/i18n-to-gettext.pl"
239 fi
240
241 if [[ ${NO_GETTEXT_HACK} == "1" ]]; then
242 ewarn "Conversion to gettext disabled in ebuild"
243 return 1
244 fi
245
246 if [[ ! -x ${i18n_tool} ]]; then
247 eerror "Missing ${i18n_tool}"
248 eerror "Please re-emerge vdr"
249 die "Missing ${i18n_tool}"
250 fi
251
252 ebegin "Auto converting translations to gettext"
253 # call i18n-to-gettext tool
254 # take all texts missing tr call into special file
255 "${i18n_tool}" 2>/dev/null \
256 |sed -e '/^"/!d' \
257 -e '/^""$/d' \
258 -e 's/\(.*\)/trNOOP(\1)/' \
259 > dummy-translations-trNOOP.c
260
261 # if there were untranslated texts just run it again
262 # now the missing calls are listed in
263 # dummy-translations-trNOOP.c
264 if [[ -s dummy-translations-trNOOP.c ]]; then
265 "${i18n_tool}" &>/dev/null
266 fi
267
268 # now use the modified Makefile
269 if [[ -f Makefile.new ]]; then
270 mv Makefile.new Makefile
271 eend 0 ""
272 else
273 eend 1 "Conversion to gettext failed. Plugin needs fixing."
274 return 1
275 fi
276}
277
278vdr_i18n_disable_gettext() {
279 #einfo "Disabling gettext support in plugin"
280
281 # Remove i18n Target if using older vdr
282 sed -i Makefile \
283 -e '/^all:/s/ i18n//'
284}
285
286vdr_i18n() {
287 if vdr_has_gettext; then
288 #einfo "VDR has gettext support"
289 if plugin_has_gettext; then
290 #einfo "Plugin has gettext support, fine"
291 if [[ ${NO_GETTEXT_HACK} == "1" ]]; then
292 ewarn "Please remove unneeded NO_GETTEXT_HACK from ebuild."
293 fi
294 else
295 vdr_i18n_convert_to_gettext
296 if [[ $? != 0 ]]; then
297 eerror ""
298 eerror "Plugin will have only english OSD texts"
299 eerror "it needs manual fixing."
300 fi
159 fi 301 fi
302 else
303 #einfo "VDR has no gettext support"
304 if plugin_has_gettext; then
305 vdr_i18n_disable_gettext
160 fi 306 fi
307 fi
161} 308}
309
310vdr-plugin_copy_source_tree() {
311 pushd . >/dev/null
312 cp -r "${S}" "${T}"/source-tree
313 cd "${T}"/source-tree
314 cp "${WORKDIR}"/Makefile.before Makefile
315 # TODO: Fix this, maybe no longer needed
316 sed -i Makefile \
317 -e "s:^DVBDIR.*$:DVBDIR = ${DVB_INCLUDE_DIR}:" \
318 -e 's:^CXXFLAGS:#CXXFLAGS:' \
319 -e 's:-I$(DVBDIR)/include:-I$(DVBDIR):' \
320 -e 's:-I$(VDRDIR) -I$(DVBDIR):-I$(DVBDIR) -I$(VDRDIR):'
321 popd >/dev/null
322}
323
324vdr-plugin_install_source_tree() {
325 einfo "Installing sources"
326 destdir="${VDRSOURCE_DIR}/vdr-${VDRVERSION}/PLUGINS/src/${VDRPLUGIN}"
327 insinto "${destdir}-${PV}"
328 doins -r "${T}"/source-tree/*
329
330 dosym "${VDRPLUGIN}-${PV}" "${destdir}"
331}
332
333vdr-plugin_print_enable_command() {
334 local p_name c=0 l=""
335 for p_name in ${vdr_plugin_list}; do
336 c=$(( c+1 ))
337 l="$l ${p_name#vdr-}"
338 done
339
340 elog
341 case $c in
342 1) elog "Installed plugin${l}" ;;
343 *) elog "Installed $c plugins:${l}" ;;
344 esac
345 elog "To activate a plugin execute this command:"
346 elog "\teselect vdr-plugin enable <plugin_name> ..."
347 elog
348}
349
350has_vdr() {
351 [[ -f "${VDR_INCLUDE_DIR}"/config.h ]]
352}
353
354## exported functions
162 355
163vdr-plugin_pkg_setup() { 356vdr-plugin_pkg_setup() {
164 # -fPIC is needed for shared objects on some platforms (amd64 and others) 357 # -fPIC is needed for shared objects on some platforms (amd64 and others)
165 append-flags -fPIC 358 append-flags -fPIC
166 359
360 # Plugins need to be compiled with position independent code, otherwise linking
361 # VDR against it will fail
362 if has_version ">=media-video/vdr-1.7.13"; then
363 append-flags -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE
364 fi
365
167 # Where should the plugins live in the filesystem 366 # Where should the plugins live in the filesystem
168 VDR_PLUGIN_DIR="/usr/$(get_libdir)/vdr/plugins" 367 VDR_PLUGIN_DIR="/usr/$(get_libdir)/vdr/plugins"
169 VDR_CHECKSUM_DIR="${VDR_PLUGIN_DIR%/plugins}/checksums" 368 VDR_CHECKSUM_DIR="${VDR_PLUGIN_DIR%/plugins}/checksums"
170 369
171 # was /usr/lib/... some time ago 370 # was /usr/lib/... some time ago
174 373
175 # Pathes to includes 374 # Pathes to includes
176 VDR_INCLUDE_DIR="/usr/include/vdr" 375 VDR_INCLUDE_DIR="/usr/include/vdr"
177 DVB_INCLUDE_DIR="/usr/include" 376 DVB_INCLUDE_DIR="/usr/include"
178 377
179
180 TMP_LOCALE_DIR="${WORKDIR}/tmp-locale" 378 TMP_LOCALE_DIR="${WORKDIR}/tmp-locale"
181 LOCDIR="/usr/share/vdr/locale"
182 if has_version ">=media-video/vdr-1.5.7"; then 379 if has_version ">=media-video/vdr-1.6.0_p2-r7"; then
183 USE_GETTEXT=1 380 LOCDIR="/usr/share/locale"
184 else 381 else
185 USE_GETTEXT=0 382 LOCDIR="/usr/share/vdr/locale"
383 fi
384
385 if ! has_vdr; then
386 # set to invalid values to detect abuses
387 VDRVERSION="eclass_no_vdr_installed"
388 APIVERSION="eclass_no_vdr_installed"
389
390 if [[ "${GENTOO_VDR_CONDITIONAL:-no}" = "yes" ]] && ! use vdr; then
391 einfo "VDR not found!"
392 else
393 # if vdr is required
394 die "VDR not found!"
186 fi 395 fi
396 return
397 fi
187 398
188 VDRVERSION=$(awk -F'"' '/define VDRVERSION/ {print $2}' ${VDR_INCLUDE_DIR}/config.h) 399 VDRVERSION=$(awk -F'"' '/define VDRVERSION/ {print $2}' "${VDR_INCLUDE_DIR}"/config.h)
189 APIVERSION=$(awk -F'"' '/define APIVERSION/ {print $2}' ${VDR_INCLUDE_DIR}/config.h) 400 APIVERSION=$(awk -F'"' '/define APIVERSION/ {print $2}' "${VDR_INCLUDE_DIR}"/config.h)
190 [[ -z ${APIVERSION} ]] && APIVERSION="${VDRVERSION}" 401 [[ -z ${APIVERSION} ]] && APIVERSION="${VDRVERSION}"
191 402
192 einfo "Building ${PF} against vdr-${VDRVERSION}" 403 einfo "Compiling against"
193 einfo "APIVERSION: ${APIVERSION}" 404 einfo "\tvdr-${VDRVERSION} [API version ${APIVERSION}]"
405
406
407 if [ -n "${VDR_LOCAL_PATCHES_DIR}" ]; then
408 eerror "Using VDR_LOCAL_PATCHES_DIR is deprecated!"
409 eerror "Please move all your patches into"
410 eerror "${EROOT}/etc/portage/patches/${CATEGORY}/${P}"
411 eerror "and remove or unset the VDR_LOCAL_PATCHES_DIR variable."
412 die
413 fi
414}
415
416vdr-plugin_src_util() {
417 while [ "$1" ]; do
418 case "$1" in
419 all)
420 vdr-plugin_src_util unpack add_local_patch patchmakefile i18n
421 ;;
422 prepare|all_but_unpack)
423 vdr-plugin_src_util add_local_patch patchmakefile i18n
424 ;;
425 unpack)
426 base_src_unpack
427 ;;
428 add_local_patch)
429 cd "${S}" || die "Could not change to plugin-source-directory!"
430 epatch_user
431 ;;
432 patchmakefile)
433 cd "${S}" || die "Could not change to plugin-source-directory!"
434 vdr_patchmakefile
435 ;;
436 i18n)
437 cd "${S}" || die "Could not change to plugin-source-directory!"
438 vdr_i18n
439 ;;
440 esac
441
442 shift
443 done
194} 444}
195 445
196vdr-plugin_src_unpack() { 446vdr-plugin_src_unpack() {
197 if [[ -z ${VDR_INCLUDE_DIR} ]]; then 447 if [[ -z ${VDR_INCLUDE_DIR} ]]; then
198 eerror "Wrong use of vdr-plugin.eclass." 448 eerror "Wrong use of vdr-plugin.eclass."
199 eerror "An ebuild for a vdr-plugin will not work without calling vdr-plugin_pkg_setup." 449 eerror "An ebuild for a vdr-plugin will not work without calling vdr-plugin_pkg_setup."
200 echo 450 echo
201 eerror "Please report this at bugs.gentoo.org." 451 eerror "Please report this at bugs.gentoo.org."
202 die "vdr-plugin_pkg_setup not called!" 452 die "vdr-plugin_pkg_setup not called!"
203 fi 453 fi
204 [ -z "$1" ] && vdr-plugin_src_unpack unpack add_local_patch patchmakefile i18n 454 if [ -z "$1" ]; then
455 case "${EAPI:-0}" in
456 2|3|4)
457 vdr-plugin_src_util unpack
458 ;;
459 *)
460 vdr-plugin_src_util all
461 ;;
462 esac
463
464 else
465 vdr-plugin_src_util $@
466 fi
467}
468
469vdr-plugin_src_prepare() {
470 base_src_prepare
471 vdr-plugin_src_util prepare
472}
473
474vdr-plugin_src_compile() {
475 [ -z "$1" ] && vdr-plugin_src_compile copy_source compile
205 476
206 while [ "$1" ]; do 477 while [ "$1" ]; do
207 478
208 case "$1" in 479 case "$1" in
209 all_but_unpack) 480 copy_source)
210 vdr-plugin_src_unpack add_local_patch patchmakefile i18n
211 ;;
212 unpack)
213 base_src_unpack
214 ;;
215 patchmakefile)
216 if ! cd ${S}; then
217 ewarn "There seems to be no plugin-directory with the name ${S##*/}"
218 ewarn "Perhaps you find one among these:"
219 cd "${WORKDIR}"
220 ewarn "$(/bin/ls -1 ${WORKDIR})"
221 die "Could not change to plugin-source-directory!"
222 fi
223
224 einfo "Patching Makefile"
225 [[ -e Makefile ]] || die "Makefile of plugin can not be found!"
226 cp Makefile "${WORKDIR}"/Makefile.before
227
228 sed -i Makefile \
229 -e '1i\#Makefile was patched by vdr-plugin.eclass'
230
231 ebegin " Setting Pathes"
232 sed -i Makefile \
233 -e "s:^VDRDIR.*$:VDRDIR = ${VDR_INCLUDE_DIR}:" \
234 -e "s:^DVBDIR.*$:DVBDIR = ${DVB_INCLUDE_DIR}:" \
235 -e "s:^LIBDIR.*$:LIBDIR = ${S}:" \
236 -e "s:^TMPDIR.*$:TMPDIR = ${T}:" \
237 -e 's:-I$(VDRDIR)/include -I$(DVBDIR)/include:-I$(DVBDIR)/include -I$(VDRDIR)/include:' \
238 -e 's:-I$(VDRDIR)/include:-I'"${VDR_INCLUDE_DIR%vdr}"':' \
239 -e 's:-I$(DVBDIR)/include:-I$(DVBDIR):'
240 eend $?
241
242 ebegin " Converting to APIVERSION"
243 sed -i Makefile \
244 -e 's:^APIVERSION = :APIVERSION ?= :' \
245 -e 's:$(LIBDIR)/$@.$(VDRVERSION):$(LIBDIR)/$@.$(APIVERSION):' \
246 -e '2i\APIVERSION = '"${APIVERSION}"
247 eend $?
248
249 ebegin " Correcting Compile-Flags"
250 sed -i Makefile \
251 -e 's:^CXXFLAGS:#CXXFLAGS:' \
252 -e '/LDFLAGS/!s:-shared:$(LDFLAGS) -shared:'
253 eend $?
254
255 ebegin " Disabling file stripping"
256 sed -i Makefile \
257 -e '/@.*strip/d' \
258 -e '/strip \$(LIBDIR)\/\$@/d' \
259 -e '/^STRIP =/d' \
260 -e '/@.*\$(STRIP)/d'
261 eend $?
262
263 # Use a file instead of an variable as single-stepping via ebuild
264 # destroys environment.
265 touch ${WORKDIR}/.vdr-plugin_makefile_patched
266 ;;
267 add_local_patch)
268 cd ${S}
269 if test -d "${VDR_LOCAL_PATCHES_DIR}/${PN}"; then
270 echo
271 einfo "Applying local patches"
272 for LOCALPATCH in ${VDR_LOCAL_PATCHES_DIR}/${PN}/${PV}/*.{diff,patch}; do
273 test -f "${LOCALPATCH}" && epatch "${LOCALPATCH}"
274 done
275 fi
276 ;;
277 i18n)
278 cd ${S}
279 if [[ ${USE_GETTEXT} = 0 ]]; then
280 # Remove i18n Target if using older vdr
281 sed -i Makefile \
282 -e '/^all:/s/ i18n//'
283 elif [[ ${USE_GETTEXT} = 1 && ! -d po && ${NO_GETTEXT_HACK} != 1 ]]; then
284 einfo "Converting translations to gettext"
285
286 local i18n_tool=/usr/share/vdr/bin/i18n-to-gettext.pl
287 if [[ ! -x ${i18n_tool} ]]; then
288 eerror "Missing ${i18n_tool}"
289 eerror "Please re-emerge vdr"
290 die "Missing ${i18n_tool}"
291 fi
292
293 # call i18n-to-gettext tool
294 # take all texts missing tr call into special file
295 ${i18n_tool} 2>/dev/null \
296 |sed -e '/^"/!d' \
297 -e '/^""$/d' \
298 -e 's/\(.*\)/trNOOP(\1)/' \
299 > dummy-translations-trNOOP.c
300
301 # if there were untranslated texts just run it again
302 # now the missing calls are listed in
303 # dummy-translations-trNOOP.c
304 if [[ -s dummy-translations-trNOOP.c ]]; then
305 ${i18n_tool} &>/dev/null
306 fi
307
308 # now use the modified Makefile
309 mv Makefile.new Makefile
310 fi
311 esac
312
313 shift
314 done
315}
316
317vdr-plugin_copy_source_tree() {
318 pushd . >/dev/null
319 cp -r ${S} ${T}/source-tree
320 cd ${T}/source-tree
321 cp "${WORKDIR}"/Makefile.before Makefile
322 sed -i Makefile \
323 -e "s:^DVBDIR.*$:DVBDIR = ${DVB_INCLUDE_DIR}:" \
324 -e 's:^CXXFLAGS:#CXXFLAGS:' \
325 -e 's:-I$(DVBDIR)/include:-I$(DVBDIR):' \
326 -e 's:-I$(VDRDIR) -I$(DVBDIR):-I$(DVBDIR) -I$(VDRDIR):'
327 popd >/dev/null
328}
329
330vdr-plugin_install_source_tree() {
331 einfo "Installing sources"
332 destdir=${VDRSOURCE_DIR}/vdr-${VDRVERSION}/PLUGINS/src/${VDRPLUGIN}
333 insinto ${destdir}-${PV}
334 doins -r ${T}/source-tree/*
335
336 dosym ${VDRPLUGIN}-${PV} ${destdir}
337}
338
339vdr-plugin_src_compile() {
340 [ -z "$1" ] && vdr-plugin_src_compile prepare compile
341
342 while [ "$1" ]; do
343
344 case "$1" in
345 prepare)
346 [[ -n "${VDRSOURCE_DIR}" ]] && vdr-plugin_copy_source_tree 481 [[ -n "${VDRSOURCE_DIR}" ]] && vdr-plugin_copy_source_tree
347 ;; 482 ;;
348 compile) 483 compile)
349 if [[ ! -f ${WORKDIR}/.vdr-plugin_makefile_patched ]]; then 484 if [[ ! -f ${WORKDIR}/.vdr-plugin_makefile_patched ]]; then
350 eerror "Wrong use of vdr-plugin.eclass." 485 eerror "Wrong use of vdr-plugin.eclass."
352 eerror "calling vdr-plugin_src_unpack to patch the Makefile." 487 eerror "calling vdr-plugin_src_unpack to patch the Makefile."
353 echo 488 echo
354 eerror "Please report this at bugs.gentoo.org." 489 eerror "Please report this at bugs.gentoo.org."
355 die "vdr-plugin_src_unpack not called!" 490 die "vdr-plugin_src_unpack not called!"
356 fi 491 fi
357 cd ${S} 492 cd "${S}"
493
494 BUILD_TARGETS=${BUILD_TARGETS:-${VDRPLUGIN_MAKE_TARGET:-all}}
358 495
359 emake ${BUILD_PARAMS} \ 496 emake ${BUILD_PARAMS} \
360 ${VDRPLUGIN_MAKE_TARGET:-all} \ 497 ${BUILD_TARGETS} \
361 LOCALEDIR="${TMP_LOCALE_DIR}" \ 498 LOCALEDIR="${TMP_LOCALE_DIR}" \
499 LIBDIR="${S}" \
500 TMPDIR="${T}" \
362 || die "emake failed" 501 || die "emake failed"
363 ;; 502 ;;
364 esac 503 esac
365 504
366 shift 505 shift
370vdr-plugin_src_install() { 509vdr-plugin_src_install() {
371 [[ -n "${VDRSOURCE_DIR}" ]] && vdr-plugin_install_source_tree 510 [[ -n "${VDRSOURCE_DIR}" ]] && vdr-plugin_install_source_tree
372 cd "${WORKDIR}" 511 cd "${WORKDIR}"
373 512
374 if [[ -n ${VDR_MAINTAINER_MODE} ]]; then 513 if [[ -n ${VDR_MAINTAINER_MODE} ]]; then
375 local mname=${P}-Makefile 514 local mname="${P}-Makefile"
376 cp "${S}"/Makefile ${mname}.patched 515 cp "${S}"/Makefile "${mname}.patched"
377 cp Makefile.before ${mname}.before 516 cp Makefile.before "${mname}.before"
378 517
379 diff -u ${mname}.before ${mname}.patched > ${mname}.diff 518 diff -u "${mname}.before" "${mname}.patched" > "${mname}.diff"
380 519
381 insinto "/usr/share/vdr/maintainer-data/makefile-changes" 520 insinto "/usr/share/vdr/maintainer-data/makefile-changes"
382 doins ${mname}.diff 521 doins "${mname}.diff"
383 522
384 insinto "/usr/share/vdr/maintainer-data/makefile-before" 523 insinto "/usr/share/vdr/maintainer-data/makefile-before"
385 doins ${mname}.before 524 doins "${mname}.before"
386 525
387 insinto "/usr/share/vdr/maintainer-data/makefile-patched" 526 insinto "/usr/share/vdr/maintainer-data/makefile-patched"
388 doins ${mname}.patched 527 doins "${mname}.patched"
389 528
390 fi 529 fi
530
531
391 532
392 cd "${S}" 533 cd "${S}"
393 insinto "${VDR_PLUGIN_DIR}" 534 insinto "${VDR_PLUGIN_DIR}"
394 doins libvdr-*.so.* 535 doins libvdr-*.so.*
395 536
396 if [[ ${USE_GETTEXT} = 1 && -d ${TMP_LOCALE_DIR} ]]; then 537 # create list of all created plugin libs
538 vdr_plugin_list=""
539 local p_name
540 for p in libvdr-*.so.*; do
541 p_name="${p%.so*}"
542 p_name="${p_name#lib}"
543 vdr_plugin_list="${vdr_plugin_list} ${p_name}"
544 done
545
546 create_header_checksum_file ${vdr_plugin_list}
547 create_plugindb_file ${vdr_plugin_list}
548
549 if vdr_has_gettext && [[ -d ${TMP_LOCALE_DIR} ]]; then
397 einfo "Installing locales" 550 einfo "Installing locales"
398 cd "${TMP_LOCALE_DIR}" 551 cd "${TMP_LOCALE_DIR}"
399 insinto "${LOCDIR}" 552 insinto "${LOCDIR}"
400 doins -r * 553 doins -r *
401 fi 554 fi
419 572
420 if [[ -n ${VDR_RCADDON_FILE} ]]; then 573 if [[ -n ${VDR_RCADDON_FILE} ]]; then
421 insinto "${VDR_RC_DIR}" 574 insinto "${VDR_RC_DIR}"
422 newins "${VDR_RCADDON_FILE}" plugin-${VDRPLUGIN}.sh 575 newins "${VDR_RCADDON_FILE}" plugin-${VDRPLUGIN}.sh
423 fi 576 fi
424
425 create_header_checksum_file
426 create_plugindb_file
427} 577}
428 578
429vdr-plugin_pkg_postinst() { 579vdr-plugin_pkg_postinst() {
430 if has_version "<=media-tv/vdrplugin-rebuild-0.1"; then 580 vdr-plugin_print_enable_command
431 update_vdrplugindb 581
432 fi
433 elog
434 elog "The vdr plugin ${VDRPLUGIN} has now been installed."
435 elog "To activate execute the following command:"
436 elog
437 elog " emerge --config ${PN}"
438 elog
439 if [[ -n "${VDR_CONFD_FILE}" ]]; then 582 if [[ -n "${VDR_CONFD_FILE}" ]]; then
440 elog "And have a look at the config-file" 583 elog "Please have a look at the config-file"
441 elog "/etc/conf.d/vdr.${VDRPLUGIN}" 584 elog "\t/etc/conf.d/vdr.${VDRPLUGIN}"
442 elog 585 elog
443 fi 586 fi
444} 587}
445 588
446vdr-plugin_pkg_postrm() { 589vdr-plugin_pkg_postrm() {
447 if has_version "<=media-tv/vdrplugin-rebuild-0.1"; then
448 remove_vdrplugindb
449 fi
450 delete_orphan_plugindb_file 590 delete_orphan_plugindb_file
451} 591}
452 592
453vdr-plugin_pkg_config_final() {
454 diff ${conf_orig} ${conf}
455 rm ${conf_orig}
456}
457
458vdr-plugin_pkg_config_old() {
459 elog "Using interface of gentoo-vdr-scripts-0.3.6 and older"
460 if [[ -z "${INSTALLPLUGIN}" ]]; then
461 INSTALLPLUGIN="${VDRPLUGIN}"
462 fi
463 # First test if plugin is already inside PLUGINS
464 local conf=/etc/conf.d/vdr
465 conf_orig=${conf}.before_emerge_config
466 cp ${conf} ${conf_orig}
467
468 elog "Reading ${conf}"
469 if ! grep -q "^PLUGINS=" ${conf}; then
470 local LINE=$(sed ${conf} -n -e '/^#.*PLUGINS=/=' | tail -n 1)
471 if [[ -n "${LINE}" ]]; then
472 sed -e ${LINE}'a PLUGINS=""' -i ${conf}
473 else
474 echo 'PLUGINS=""' >> ${conf}
475 fi
476 unset LINE
477 fi
478
479 unset PLUGINS
480 PLUGINS=$(source /etc/conf.d/vdr; echo ${PLUGINS})
481
482 active=0
483 for p in ${PLUGINS}; do
484 if [[ "${p}" == "${INSTALLPLUGIN}" ]]; then
485 active=1
486 break;
487 fi
488 done
489
490 if [[ "${active}" == "1" ]]; then
491 elog "${INSTALLPLUGIN} already activated"
492 echo
493 read -p "Do you want to deactivate ${INSTALLPLUGIN} (yes/no) " answer
494 if [[ "${answer}" != "yes" ]]; then
495 elog "aborted"
496 return
497 fi
498 elog "Removing ${INSTALLPLUGIN} from active plugins."
499 local LINE=$(sed ${conf} -n -e '/^PLUGINS=.*\<'${INSTALLPLUGIN}'\>/=' | tail -n 1)
500 sed -i ${conf} -e ${LINE}'s/\<'${INSTALLPLUGIN}'\>//' \
501 -e ${LINE}'s/ \( \)*/ /g' \
502 -e ${LINE}'s/ "/"/g' \
503 -e ${LINE}'s/" /"/g'
504
505 vdr-plugin_pkg_config_final
506 return
507 fi
508
509
510 elog "Adding ${INSTALLPLUGIN} to active plugins."
511 local LINE=$(sed ${conf} -n -e '/^PLUGINS=/=' | tail -n 1)
512 sed -i ${conf} -e ${LINE}'s/^PLUGINS=" *\(.*\)"/PLUGINS="\1 '${INSTALLPLUGIN}'"/' \
513 -e ${LINE}'s/ \( \)*/ /g' \
514 -e ${LINE}'s/ "/"/g' \
515 -e ${LINE}'s/" /"/g'
516
517 vdr-plugin_pkg_config_final
518}
519
520vdr-plugin_pkg_config_new() {
521 elog "Using interface introduced with gentoo-vdr-scripts-0.3.7"
522 if [[ -z "${INSTALLPLUGIN}" ]]; then
523 INSTALLPLUGIN="${VDRPLUGIN}"
524 fi
525
526 active=0
527 # First test if plugin is already inside PLUGINS
528 local conf=/etc/conf.d/vdr.plugins
529 exec 3<${conf}
530 while read -u 3 line; do
531 [[ ${line} == "" ]] && continue
532 [[ ${line:0:1} == "#" ]] && continue
533 set -- ${line}
534 [[ ${1} == ${INSTALLPLUGIN} ]] && active=1
535 done
536 exec 3<&-
537
538 if [[ $active == 0 ]]; then
539 elog "Adding ${INSTALLPLUGIN} to active plugins."
540
541 # The pure edit process.
542 echo "${INSTALLPLUGIN}" >> "${conf}"
543 else
544 elog "${INSTALLPLUGIN} already activated"
545 echo
546 read -p "Do you want to deactivate ${INSTALLPLUGIN} (yes/no) " answer
547 if [[ "${answer}" != "yes" ]]; then
548 elog "aborted"
549 return
550 fi
551 elog "Removing ${INSTALLPLUGIN} from active plugins."
552
553 # The pure edit process
554 sed -i "${conf}" -e "/^[[:space:]]*${INSTALLPLUGIN}[[:space:]]*\$/d"
555 fi
556}
557
558vdr-plugin_pkg_config() { 593vdr-plugin_pkg_config() {
559 if has_version ">media-tv/gentoo-vdr-scripts-0.3.6"; then 594:
560 vdr-plugin_pkg_config_new
561 else
562 vdr-plugin_pkg_config_old
563 fi
564} 595}
565 596
566fix_vdr_libsi_include() 597case "${EAPI:-0}" in
567{ 598 2|3|4)
568 einfo "Fixing include of libsi-headers" 599 EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_compile src_install pkg_postinst pkg_postrm pkg_config
569 local f 600 ;;
570 for f; do 601 *)
571 sed -i "${f}" \
572 -e '/#include/s:"\(.*libsi.*\)":<\1>:' \
573 -e '/#include/s:<.*\(libsi/.*\)>:<vdr/\1>:'
574 done
575}
576
577EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install pkg_postinst pkg_postrm pkg_config 602 EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install pkg_postinst pkg_postrm pkg_config
603 ;;
604esac

Legend:
Removed from v.1.49  
changed lines
  Added in v.1.83

  ViewVC Help
Powered by ViewVC 1.1.20